<template>
  <Page>
    <ActionBar title="Create your event">
      <NavigationButton text="Go back" android.systemIcon="ic_menu_back" @tap="$navigateBack" />
    </ActionBar>
    <ScrollView>
      <AbsoluteLayout height="auto">
        <StackLayout ref="stackRef" width="100%" height="100%" stretchLastChild="false" class="overlay">
          <FloatingLabel :enabled="contentEnabled" placeholder="Event name" v-model="name" />
          <FloatingTextView :enabled="contentEnabled" placeholder="Description" v-model="description" />
          <Label margin="50px" padding="10px" text="Select the date of your event" class="input" fontSize="18" />
          <CollapsablePanel title="Select the date of event" icon="fa-thermometer-half"
            iconset="fas" class="m-b-5">
            <StackLayout>
              <Label text="Select the date" class="panel-title" />
              <DatePicker :date="new Date()" v-model="date" />
            </StackLayout>
          </CollapsablePanel>
          <CollapsablePanel title="Select the time of event" icon="fa-thermometer-half"
            iconset="fas" class="m-b-5">
            <StackLayout>
              <Label text="Select the date" class="panel-title" />
              <TimePicker :hour="hour" :minute="minute" v-model="time" />
            </StackLayout>
          </CollapsablePanel>
          <!-- <DatePicker :date="new Date()" v-model="date" /> -->
          <Label margin="50px" padding="10px" text="Select the time of your event" class="input" fontSize="18" />
          <TimePicker :hour="hour" :minute="minute" v-model="time" />
          <Button :enabled="contentEnabled" text="Publish event" @onTap="publish" />
        </StackLayout>
        <ActivityIndicator :marginTop="pageHeight" marginLeft="50%" :busy="isLoading" @busyChange="onBusyChanged" />
 
          
      </AbsoluteLayout>
      <!-- <StackLayout stretchLastChild="false" class="overlay">

        <FloatingLabel isEnabled="false" placeholder="Event name" v-model="name" />
        <FloatingTextView placeholder="Description" v-model="description" />
        <Label margin="50px" padding="10px" text="Select the date of your event" class="input" fontSize="18" />
        <DatePicker :date="new Date()" v-model="date" />
        <Label margin="50px" padding="10px" text="Select the time of your event" class="input" fontSize="18" />
        <TimePicker :hour="hour" :minute="minute" v-model="time" />
        <Button text="Publish event" @onTap="publish" />
      </StackLayout> -->
    </ScrollView>
  </Page>
</template>

<script>
import EventBus from '~/event-bus'
import FloatingLabel from './FloatingLabel'
import FloatingTextView from './FloatingTextView'
import CollapsablePanel from './CollapsablePanel'
import { firestore } from 'nativescript-plugin-firebase'
import { mapGetters } from 'vuex';

const firebase = require("nativescript-plugin-firebase/app");

  export default {
    components: { FloatingLabel, FloatingTextView, CollapsablePanel },

    props: ['lat', 'lng', 'userId'],
    
    async created() {
      const geocodingUrl = `https://api.mapbox.com/geocoding/v5/mapbox.places/${lng}, ${lat}.json?access_token=${this.$mapboxAccessToken}`
      try {
        const { data } = await axios.get(geocodingUrl)
        if (data.hasOwnProperty('features')) {
          this.$emit('centerCoordinates', data.features[0].center)
          console.log('data.feature[0].center :', data.feature[0].center);
        }
      } catch (error) {
        console.log(error)
        throw error
      }
      this.pageHeight = this.$refs.stackRef.height /  2
      console.log('this.pageHeight :', this.pageHeight);
    },
    computed: {
      ...mapGetters({ isLoading: 'isLoading'})
    },
    data() {
      return {
          name: '',
          description: '',
          date: new Date(),
          hour: new Date().getHours(),
          minute: new Date().getMinutes(),
          time: '',
          address: '',
          pageHeight: 0,
          contentEnabled: false
          // location: {
          //   lng: '',
          //   lat: ''
          // }
      }
    },
    methods: {
      onBusyChanged() {
        console.log('busy chnged')
        this.contentEnabled = !this.contentEnabled
      },
      async publish() {
        this.onBusyChanged()
        let time = this.time
        let lat = this.lat
        let lng = this.lng

        let event = {
          name: this.name,
          description: this.description,
          date: this.date,
          lat, lng,
          participants: [this.userId],
          owner: this.userId,
          deleted: false,
          createdAt: new Date().getTime(),
          deletedAt: null,
          modifiedAt: null,
          ...time
        }
        console.log('event :', event);
        try {
          await this.$store.dispatch('createEvent', event)
          
          this.$navigateBack({clearHistory: true})
        } catch (e) {
          console.log('Failed to create an event.')
          throw e
        } finally {
          this.onBusyChanged()
        }
      },
    },
  }
</script>

<style scoped>
  /* Overlay */
  Frame {
      width: 100%;
      height: 100%;
  }

  Label {
      color: #000000;
  }
</style>
